<?php


// Cdigo-fonte em PHP 

 
header("Content-type: image/png");
$imagem = ImageCreate(600, 500);
//$fundoCorBranca = imagecolorallocate($imagem, 255, 255, 255);
//$fundoCorBege = imagecolorallocate($imagem, 255, 246, 143);
$fundoCorPreta = imagecolorallocate($imagem, 0, 0, 0);
imagefill($imagem,0,0,$fundoCorPreta);

$branca = ImageColorAllocate($imagem, 255, 255, 255);
$preta = ImageColorAllocate($imagem, 0, 0, 0);
$amarela = imagecolorallocate($imagem, 255, 255, 0);
$vermelha = imagecolorallocate($imagem, 255, 0, 0);
$verde = imagecolorallocate($imagem, 0, 255, 0);
$deeppink = imagecolorallocate($imagem, 255, 20, 147);
$azul = imagecolorallocate($imagem, 0, 0, 255);
$ciano = imagecolorallocate($imagem, 0, 255, 255);
$azulclaro = imagecolorallocate($imagem, 30, 144, 255);


// Funo parametrizada na forma T(f(x,y), g(x,y), h(x,y)) a ser plotada, sendo:
function f($x, $y) { return (2+sin(3*$y))*sin($y)*sin($x); }
function g($x, $y) { return (2+sin(3*$y))*sin($y)*cos($x); }
function h($x, $y) { return (2+sin(2*$y))*sin($y); }

$deformacao = 1;
$teta = M_PI/4;
$A = 300;
$B = 250;
$tam = 50;
$nu = 40;
$nv = 40;
$umin = 0;
$umax = 6.28;
$vmin = 0;
$vmax = 4.6;
$d1 = ($umax - $umin)/$nu;
$d2 = ($vmax - $vmin)/$nv;

for ($v = $vmin; $v <= ($vmax + $d2/2.0); $v += $d2) {
     $u = $umin;
     $x = f($u, $v);
     $y = g($u, $v);
     $z = h($u, $v);
     $X = $y - $x*cos($teta)/3;
     $Y = $z/$deformacao - $x*sin($teta)/3;
     $p1 = $A + $X*$tam;
     $p2 = $B - $Y*$tam;
     for ($u = $umin; $u <= $umax; $u += $d1) {
          $x = f($u, $v);
          $y = g($u, $v);
          $z = h($u, $v);
          $X = $y - $x*cos($teta)/3;
          $Y = $z/$deformacao - $x*sin($teta)/3;
          imageLine($imagem, round($A + $X*$tam), round($B - $Y*$tam), round($p1), round($p2), $ciano);
          $p1 = $A + $X*$tam;
          $p2 = $B - $Y*$tam;
     }
     $u = $umax;
     $x = f($u, $v);
     $y = g($u, $v);
     $z = h($u, $v);
     $X = $y - $x*cos($teta)/3;
     $Y = $z/$deformacao - $x*sin($teta)/3;
     imageLine($imagem, round($A + $X*$tam), round($B - $Y*$tam), round($p1), round($p2), $ciano);
}

for ($u = $umin; $u <= ($umax + $d1/2.0); $u += $d1) {
     $v = $vmin;
     $x = f($u, $v);
     $y = g($u, $v);
     $z = h($u, $v);
     $X = $y - $x*cos($teta)/3;
     $Y = $z/$deformacao - $x*sin($teta)/3;
     $p1 = $A + $X*$tam;
     $p2 = $B - $Y*$tam;
     for ($v = $vmin; $v <= $vmax; $v += $d2) {
          $x = f($u, $v);
          $y = g($u, $v);
          $z = h($u, $v);
          $X = $y - $x*cos($teta)/3;
          $Y = $z/$deformacao - $x*sin($teta)/3;
          imageLine($imagem, round($A + $X*$tam), round($B - $Y*$tam), round($p1), round($p2), $deeppink);
          $p1 = $A + $X*$tam;
          $p2 = $B - $Y*$tam;
     }
     $v = $vmax;
     $x = f($u, $v);
     $y = g($u, $v);
     $z = h($u, $v);
     $X = $y - $x*cos($teta)/3;
     $Y = $z/$deformacao - $x*sin($teta)/3;
     imageLine($imagem, round($A + $X*$tam), round($B - $Y*$tam), round($p1), round($p2), $deeppink);
}

// Mostra as funes
//imageString($imagem, 4, 15, 425,"T(x,y) = (f(x,y), g(x,y), h(x,y)),  com x em [".$umin.", ".$umax."] e y em [".$vmin.", ".$vmax."]", $branca);
//imageString($imagem, 4, 15, 445,"f(x,y) = ".$funcao1, $branca);
//imageString($imagem, 4, 15, 460,"g(x,y) = ".$funcao2, $branca);
//imageString($imagem, 4, 15, 475,"h(x,y) = ".$funcao3, $branca);

// Mostra a imagem no navegador:
imagePng($imagem);

// Salva a imagem em arquivo:
//$arquivo = "grafico3d_gerado.png";
//imagePng($imagem,$arquivo);

// Remove a imagem da memria:
ImageDestroy($imagem);

?>
